OGRE-Next: Ogre::AnimableValue Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
Ogre::AnimableValue Class Referenceabstract
Core » Animation

Defines an object property which is animable, i.e. More...

`#include <OgreAnimable.h>`

Inheritance diagram for Ogre::AnimableValue:
[legend]

## Public Types
enum | ValueType { INT , REAL , VECTOR2 , VECTOR3 , VECTOR4 , QUATERNION , COLOUR , RADIAN , DEGREE }
| The type of the value being animated. More...

## Public Member Functions
| AnimableValue (ValueType t)
virtual | ~AnimableValue ()
virtual void | applyDeltaValue (const Any &val)
| Apply delta value.
virtual void | applyDeltaValue (const ColourValue &)
| Apply delta value.
virtual void | applyDeltaValue (const Degree &)
| Apply delta value.
virtual void | applyDeltaValue (const Quaternion &)
| Apply delta value.
virtual void | applyDeltaValue (const Radian &)
| Apply delta value.
virtual void | applyDeltaValue (const Vector2 &)
| Apply delta value.
virtual void | applyDeltaValue (const Vector3 &)
| Apply delta value.
virtual void | applyDeltaValue (const Vector4 &)
| Apply delta value.
virtual void | applyDeltaValue (int)
| Apply delta value.
virtual void | applyDeltaValue (Real)
| Set value.
ValueType | getType () const
| Gets the value type of this animable value.
virtual void | resetToBaseValue ()
virtual void | setCurrentStateAsBaseValue ()=0
| Sets the current state as the 'base' value; used for delta animation.
virtual void | setValue (const Any &val)
| Set value.
virtual void | setValue (const ColourValue &)
| Set value.
virtual void | setValue (const Degree &)
| Set value.
virtual void | setValue (const Quaternion &)
| Set value.
virtual void | setValue (const Radian &)
| Set value.
virtual void | setValue (const Vector2 &)
| Set value.
virtual void | setValue (const Vector3 &)
| Set value.
virtual void | setValue (const Vector4 &)
| Set value.
virtual void | setValue (int)
| Set value.
virtual void | setValue (Real)
| Set value.

## Detailed Description

Defines an object property which is animable, i.e.

may be keyframed.

Remarks
  Animable properties are those which can be altered over time by a predefined keyframe sequence. They may be set directly, or they may be modified from their existing state (common if multiple animations are expected to apply at once). Implementors of this interface are expected to override the 'setValue', 'setCurrentStateAsBaseValue' and 'applyDeltaValue' methods appropriate to the type in question, and to initialise the type.

  AnimableValue instances are accessible through any class which extends AnimableObject in order to expose it's animable properties.

Note
  This class is an instance of the Adapter pattern, since it generalises access to a particular property. Whilst it could have been templated such that the type which was being referenced was compiled in, this would make it more difficult to aggregated generically, and since animations are often comprised of multiple properties it helps to be able to deal with all values through a single class.

## Member Enumeration Documentation

## ◆ ValueType

enum Ogre::AnimableValue::ValueType

The type of the value being animated.

Enumerator
INT |
REAL |
VECTOR2 |
VECTOR3 |
VECTOR4 |
QUATERNION |
COLOUR |
RADIAN |
DEGREE |

## Constructor & Destructor Documentation

## ◆ AnimableValue()

Ogre::AnimableValue::AnimableValue | ( | ValueType | t | ) |
| inline

## ◆ ~AnimableValue()

virtual Ogre::AnimableValue::~AnimableValue | ( |  | ) |
| inlinevirtual

## Member Function Documentation

## ◆ applyDeltaValue() [1/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const Any & | val | ) |
| virtual

Apply delta value.

## ◆ applyDeltaValue() [2/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const ColourValue & |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [3/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const Degree & |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [4/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const Quaternion & |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [5/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const Radian & |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [6/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const Vector2 & |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [7/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const Vector3 & |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [8/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | const Vector4 & |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [9/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | int |  | ) |
| inlinevirtual

Apply delta value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ applyDeltaValue() [10/10]

virtual void Ogre::AnimableValue::applyDeltaValue | ( | Real |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ getType()

ValueType Ogre::AnimableValue::getType | ( |  | ) | const
| inline

Gets the value type of this animable value.

## ◆ resetToBaseValue()

virtual void Ogre::AnimableValue::resetToBaseValue | ( |  | ) |
| virtual

## ◆ setCurrentStateAsBaseValue()

virtual void Ogre::AnimableValue::setCurrentStateAsBaseValue | ( |  | ) |
| pure virtual

Sets the current state as the 'base' value; used for delta animation.

## ◆ setValue() [1/10]

virtual void Ogre::AnimableValue::setValue | ( | const Any & | val | ) |
| virtual

Set value.

## ◆ setValue() [2/10]

virtual void Ogre::AnimableValue::setValue | ( | const ColourValue & |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [3/10]

virtual void Ogre::AnimableValue::setValue | ( | const Degree & |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [4/10]

virtual void Ogre::AnimableValue::setValue | ( | const Quaternion & |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [5/10]

virtual void Ogre::AnimableValue::setValue | ( | const Radian & |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [6/10]

virtual void Ogre::AnimableValue::setValue | ( | const Vector2 & |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [7/10]

virtual void Ogre::AnimableValue::setValue | ( | const Vector3 & |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [8/10]

virtual void Ogre::AnimableValue::setValue | ( | const Vector4 & |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [9/10]

virtual void Ogre::AnimableValue::setValue | ( | int |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## ◆ setValue() [10/10]

virtual void Ogre::AnimableValue::setValue | ( | Real |  | ) |
| inlinevirtual

Set value.

References Ogre::Exception::ERR_NOT_IMPLEMENTED, and OGRE_EXCEPT.

## Member Data Documentation

## ◆ mBaseValueInt

int Ogre::AnimableValue::mBaseValueInt

## ◆ mBaseValueReal

Real Ogre::AnimableValue::mBaseValueReal[4]

The documentation for this class was generated from the following file:

- OgreAnimable.h